'SIRDS.BAS      January 2001

'Programming by Ray Thomas      Mathematics by Patty Waltermire

'A program to produce Single Image Random Dot Stereograms

Density = 1000
InterOc = 70
Polarity = 0
VirtZ = 10
Shape = 3
PixCorrn = .5

'*** Shape 0 is the background only ***
'*** Shape 1 is a rectangle ***
'*** Shape 2 is a circle ***
'*** Shape 3 is a cone ***
'*** Shape 4 is a hemisphere ***
'*** Shape 5 is a torus ***

CLS
SCREEN 9
InitZ = VirtZ

'*** Create Density number of random coloured dots ***
'*** in a vertical strip InterOc wide ***

RANDOMIZE TIMER
FOR Count = 1 TO Density
        PosnX = (RND * InterOc) + 1
        PosnY = (RND * 350) + 1
        Colour = (RND * 15)
        PSET (PosnX, PosnY), Colour
        GOSUB DoOffSet
NEXT Count

END

DoOffSet:

' *** Redraws the dots across the screen

WHILE PosnX < 640
        GOSUB CalcZ
        IF Polarity = 0 THEN VirtZ = -VirtZ
        PosnX = PosnX + InterOc + VirtZ
        IF PosnX < 640 THEN PSET (PosnX, PosnY), Colour
WEND
RETURN

CalcZ:

'*** Calculates the virtual Z co-ordinate

VirtZ = 0
'*** Centre of screen is at 320,175 ***
'*** PixCorrn is to correct for the fact ***
'*** that screen pixels are not square ***

Dist = SQR(((PosnX - 320) * PixCorrn * (PosnX - 320)) + ((PosnY - 175) * (PosnY - 175)))

'*** Shape 1 is a rectangle ***
IF Shape = 1 THEN
        IF PosnX > 220 AND PosnX < 420 THEN
                IF PosnY > 100 AND PosnY < 250 THEN
                        VirtZ = InitZ
                END IF
        END IF
END IF

'*** Shape 2 is a circle ***
IF Shape = 2 THEN
        Rad = 100
        IF Dist < Rad THEN VirtZ = InitZ
END IF

'*** Shape 3 is a cone ***
IF Shape = 3 THEN
        Rad = 100
        Height = 40
        Result = (Rad - Dist) * (Height / Rad)
        IF Result > 0 THEN VirtZ = Result
END IF

'*** Shape 4 is a hemisphere ***
IF Shape = 4 THEN
        Rad = 60
        IF Dist < Rad THEN
                Result = SQR((Rad * Rad) - (Dist * Dist))
                VirtZ = Result / (PixCorrn * 10)
        END IF
END IF

'*** Shape 5 is a torus ***
IF Shape = 5 THEN
        IntRad = 40
        ExtRad = 100
        DiffRad = ExtRad - IntRad
        IF Dist > IntRad AND Dist < ExtRad THEN
                Result = SQR((DiffRad * DiffRad) - ((Dist - DiffRad) * (Dist - DiffRad)))
                VirtZ = Result * PixCorrn
        END IF
END IF
RETURN

